Imports System.ServiceProcess
Imports System.Timers
Imports System.IO
Imports System.Threading
Imports System.Web.Mail

Public Class Service1
    Inherits System.ServiceProcess.ServiceBase

#Region " Cdigo generado por el Diseador de componentes "

    Public Sub New()
        MyBase.New()

        ' El Diseador de componentes requiere esta llamada.
        InitializeComponent()

        ' Agregar cualquier inicializacin despus de la llamada a InitializeComponent()

    End Sub

    'UserService reemplaza a Dispose para limpiar la lista de componentes.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' El punto de entrada principal para el proceso
    <MTAThread()> _
    Shared Sub Main()
        Dim ServicesToRun() As System.ServiceProcess.ServiceBase

        ' Se puede ejecutar en el mismo proceso ms de un servicio NT. Para agregar
        ' otro servicio a este proceso, cambie la siguiente lnea a fin de
        ' crear otro objeto de servicio. Por ejemplo,
        '
        '   ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1, New MySecondUserService}
        '
        ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1}

        System.ServiceProcess.ServiceBase.Run(ServicesToRun)
    End Sub

    'Requerido por el Diseador de componentes
    Private components As System.ComponentModel.IContainer

    'NOTA: el Diseador de componentes requiere el siguiente procedimiento
    'Se puede modificar utilizando el Diseador de componentes. No lo modifique
    ' con el editor de cdigo.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Service1
        '
        Me.CanPauseAndContinue = True
        Me.CanShutdown = True
        Me.ServiceName = "ArchivosGrandes"

    End Sub

#End Region

    Private WithEvents Alarma As _
      Timers.Timer = New Timers.Timer(300000) ' 5 minutos

    Private NombreArchivoGrande As String = ""

    Sub BuscaArbol(ByVal Dir As String)
        Dim Directorio As New DirectoryInfo(Dir)

        Dim Archivos As FileInfo() = Directorio.GetFiles("*.*")
        Dim Dirs As DirectoryInfo() = Directorio.GetDirectories("*.*")

        Dim NombreArchivo As FileInfo
        For Each NombreArchivo In Archivos
            If NombreArchivo.Length >= 5 * 1024000 Then
                NombreArchivoGrande = NombreArchivo.FullName & Chr(13) & Chr(10)
            End If
        Next

        Dim NombreDirectorio As DirectoryInfo
        For Each NombreDirectorio In Dirs
            Try
                BuscaArbol(NombreDirectorio.FullName)
            Catch E As Exception
            End Try
        Next
    End Sub

    Public Sub CompruebaArchivosGrandes()
        BuscaArbol("C:\")

        If (NombreArchivoGrande.Length > 0) Then
            Dim Correo As New MailMessage()
            Dim Mensaje As SmtpMail

            Correo.To = "administrador@empresa.com"
            Correo.Subject = "Archivos grandes"
            Correo.Body = NombreArchivoGrande

            Mensaje.Send(Correo)
        End If
    End Sub

    Public Sub OnTimedEvent(ByVal source As Object, _
      ByVal e As ElapsedEventArgs) Handles Alarma.Elapsed

        Dim BuscaArchivos As Thread
        BuscaArchivos = New Thread(AddressOf CompruebaArchivosGrandes)
        BuscaArchivos.Start()
    End Sub

    Protected Overrides Sub OnStart(ByVal args() As String)
        Alarma.Enabled = True
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "ArchivosGrandes"
            Registro.WriteEntry("Servicio iniciado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnPause()
        Alarma.Enabled = False
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "ArchivosGrandes"
            Registro.WriteEntry("Servicio detenido el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnContinue()
        Alarma.Enabled = True

        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "ArchivosGrandes"
            Registro.WriteEntry("Servicio reiniciado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnShutdown()
        Alarma.Enabled = False
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "ArchivosGrandes"
            Registro.WriteEntry("Servicio apagado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnStop()
        Alarma.Enabled = False

        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "ArchivosGrandes"
            Registro.WriteEntry("Servicio terminado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

End Class
