Imports System.ServiceProcess
Imports System.Timers
Imports System.IO
Imports System.Threading

Public Class Service1
    Inherits System.ServiceProcess.ServiceBase

#Region " Cdigo generado por el Diseador de componentes "

    Public Sub New()
        MyBase.New()

        ' El Diseador de componentes requiere esta llamada.
        InitializeComponent()

        ' Agregar cualquier inicializacin despus de la llamada a InitializeComponent()

    End Sub

    'UserService reemplaza a Dispose para limpiar la lista de componentes.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' El punto de entrada principal para el proceso
    <MTAThread()> _
    Shared Sub Main()
        Dim ServicesToRun() As System.ServiceProcess.ServiceBase

        ' Se puede ejecutar en el mismo proceso ms de un servicio NT. Para agregar
        ' otro servicio a este proceso, cambie la siguiente lnea a fin de
        ' crear otro objeto de servicio. Por ejemplo,
        '
        '   ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1, New MySecondUserService}
        '
        ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1}

        System.ServiceProcess.ServiceBase.Run(ServicesToRun)
    End Sub

    'Requerido por el Diseador de componentes
    Private components As System.ComponentModel.IContainer

    'NOTA: el Diseador de componentes requiere el siguiente procedimiento
    'Se puede modificar utilizando el Diseador de componentes. No lo modifique
    ' con el editor de cdigo.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Service1
        '
        Me.CanPauseAndContinue = True
        Me.CanShutdown = True
        Me.ServiceName = "MonitorDelSistema"

    End Sub

#End Region

    Private WithEvents Alarma As _
      Timers.Timer = New Timers.Timer(300000) ' 5 minutos

    Function CuentaArbol(ByVal Dir As String)
        Dim Directorio As New DirectoryInfo(Dir)

        Dim Archivos As FileInfo() = Directorio.GetFiles("*.tmp")
        Dim Dirs As DirectoryInfo() = Directorio.GetDirectories("*.*")
        Dim NombreDirectorio As DirectoryInfo
        Dim Contador As Integer = 0

        For Each NombreDirectorio In Dirs
            Try
                Contador = Contador + CuentaArbol(NombreDirectorio.FullName)
            Catch E As Exception
            End Try
        Next

        CuentaArbol = Archivos.Length + Contador
    End Function

    Public Sub CuentaArchivosTemporales()
        Dim Registro As New EventLog("Application")
        Registro.Source = "MonitorDelSistema"
        Registro.WriteEntry("Nmero de archivos .tmp el " & Now() & " es " & _
                 CuentaArbol("C:\"))
        Registro.Close()
    End Sub

    Public Sub CuentaRegistroSucesos()
        Dim Registro As New EventLog("Application")
        Registro.Source = "MonitorDelSistema"
        Registro.WriteEntry("Nmero de entradas en el registro de sucesos el " & Now() & " es " & _
                 Registro.Entries.Count)
        Registro.Close()
    End Sub

    Public Sub OnTimedEvent(ByVal source As Object, _
      ByVal e As ElapsedEventArgs) Handles Alarma.Elapsed
        Dim CompruebaRegistro, CompruebaTemporales As Thread
        CompruebaRegistro = New Thread(AddressOf CuentaRegistroSucesos)
        CompruebaTemporales = New Thread(AddressOf CuentaArchivosTemporales)
        CompruebaRegistro.Start()
        CompruebaTemporales.Start()
    End Sub

    Protected Overrides Sub OnStart(ByVal args() As String)
        Alarma.Enabled = True
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "MonitorDelSistema"
            Registro.WriteEntry("Servicio iniciado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnPause()
        Alarma.Enabled = False
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "MonitorDelSistema"
            Registro.WriteEntry("Servicio detenido el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnContinue()
        Alarma.Enabled = True
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "MonitorDelSistema"
            Registro.WriteEntry("Servicio reiniciado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnShutdown()
        Alarma.Enabled = False
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "MonitorDelSistema"
            Registro.WriteEntry("Servicio apagado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnStop()
        Alarma.Enabled = False
        Try
            Dim Registro As New EventLog("Application")
            Registro.Source = "MonitorDelSistema"
            Registro.WriteEntry("Servicio parado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

End Class
