Imports System.ServiceProcess
Imports System.IO

Public Class Service1
    Inherits System.ServiceProcess.ServiceBase

#Region " Cdigo generado por el Diseador de componentes "

    Public Sub New()
        MyBase.New()

        ' El Diseador de componentes requiere esta llamada.
        InitializeComponent()

        ' Agregar cualquier inicializacin despus de la llamada a InitializeComponent()

    End Sub

    'UserService reemplaza a Dispose para limpiar la lista de componentes.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' El punto de entrada principal para el proceso
    <MTAThread()> _
    Shared Sub Main()
        Dim ServicesToRun() As System.ServiceProcess.ServiceBase

        ' Se puede ejecutar en el mismo proceso ms de un servicio NT. Para agregar
        ' otro servicio a este proceso, cambie la siguiente lnea a fin de
        ' crear otro objeto de servicio. Por ejemplo,
        '
        '   ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1, New MySecondUserService}
        '
        ServicesToRun = New System.ServiceProcess.ServiceBase () {New Service1}

        System.ServiceProcess.ServiceBase.Run(ServicesToRun)
    End Sub

    'Requerido por el Diseador de componentes
    Private components As System.ComponentModel.IContainer

    'NOTA: el Diseador de componentes requiere el siguiente procedimiento
    'Se puede modificar utilizando el Diseador de componentes. No lo modifique
    ' con el editor de cdigo.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Service1
        '
        Me.CanPauseAndContinue = True
        Me.CanShutdown = True
        Me.ServiceName = "ServicioBackup"

    End Sub

#End Region

    Private WithEvents MonitorArchivo As FileSystemWatcher

    Protected Sub OnChanged(ByVal From As Object, _
      ByVal e As FileSystemEventArgs) Handles MonitorArchivo.Changed

        Dim Registro As New EventLog("Application")
        Registro.Source = "ServicioBackup"
        Registro.WriteEntry("Archivo " & e.FullPath & _
           " modificado el " & DateTime.Now)
        Registro.Close()
        File.Copy(e.FullPath, "C:\Datos\Backup\" & e.Name)
    End Sub

    Protected Sub OnCreated(ByVal From As Object, _
      ByVal e As FileSystemEventArgs) Handles MonitorArchivo.Created
        Dim Registro As New EventLog("Application")
        Registro.Source = "ServicioBackup"
        Registro.WriteEntry("Archivo " & e.FullPath & _
           " creado el " & DateTime.Now)
        Registro.Close()
        File.Copy(e.FullPath, "C:\Datos\Backup\" & e.Name)
    End Sub

    Protected Overrides Sub OnStart(ByVal args() As String)
        Try
            If Not Directory.Exists("C:\Datos") Then
                Directory.CreateDirectory("C:\Datos")
            End If

            If Not Directory.Exists("C:\Datos\Backup") Then
                Directory.CreateDirectory("C:\Datos\Backup")
            End If

            MonitorArchivo = New FileSystemWatcher("C:\Datos")
            MonitorArchivo.Filter = "*.*"
            MonitorArchivo.IncludeSubdirectories = False
            MonitorArchivo.EnableRaisingEvents = True

            Dim Registro As New EventLog("Application")
            Registro.Source = "ServicioBackup"
            Registro.WriteEntry("Servicio iniciado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnPause()
        Try
            MonitorArchivo.EnableRaisingEvents = False
            Dim Registro As New EventLog("Application")
            Registro.Source = "ServicioBackup"
            Registro.WriteEntry("Servicio detenido el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnContinue()
        Try
            MonitorArchivo.EnableRaisingEvents = True

            Dim Registro As New EventLog("Application")
            Registro.Source = "ServicioBackup"
            Registro.WriteEntry("Servicio reiniciado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnShutdown()
        Try
            MonitorArchivo.EnableRaisingEvents = False

            Dim Registro As New EventLog("Application")
            Registro.Source = "ServicioBackup"
            Registro.WriteEntry("Servicio apagado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

    Protected Overrides Sub OnStop()
        Try
            MonitorArchivo.EnableRaisingEvents = False

            Dim Registro As New EventLog("Application")
            Registro.Source = "ServicioBackup"
            Registro.WriteEntry("Servicio terminado el " & DateTime.Now)
            Registro.Close()
        Catch E As Exception
        End Try
    End Sub

End Class
