Imports System.Reflection

Module Module1
    Class Base
        Public IDProducto As String
        Public Peso As Double
        Private PrecioProducto As Double

        Public Sub New(ByVal IDProducto As String, _
          ByVal PrecioProducto As Double, ByVal Peso As Double)
            Me.IDProducto = IDProducto
            Me.PrecioProducto = PrecioProducto
            Me.Peso = Peso
        End Sub

        Public Sub MuestraProducto()
            Console.WriteLine("Identificador de producto: " & IDProducto)
            Console.WriteLine("Peso: " & Peso)
            Console.WriteLine("Precio de producto: " & PrecioProducto)
        End Sub

        Public Property Precio() As Double
            Get
                Return PrecioProducto
            End Get
            Set(ByVal Valor As Double)
                If (Valor >= 0) And (Valor <= 100) Then
                    PrecioProducto = Valor
                Else
                    Console.WriteLine("Precio no vlido para " & IDProducto)
                    PrecioProducto = 0
                End If
            End Set
        End Property
    End Class

    Class Derived
        Inherits Base
        Implements IFormattable

        Public Ttulo As String
        Public Autor As String
        Public Editorial As String

        Public Overridable Overloads Function ToString(ByVal _
          Format As String, ByVal Provider As IFormatProvider) _
          As String Implements IFormattable.ToString

            ToString = Ttulo

        End Function

        Public Sub New(ByVal Ttulo As String, ByVal Autor As String, _
          ByVal Editorial As String, ByVal Precio As Double, _
          ByVal Peso As Double)
            MyBase.New("11122", Precio, Peso)

            Me.Ttulo = Ttulo
            Me.Autor = Autor
            Me.Editorial = Editorial
        End Sub

        Public Sub MuestraLibro()
            Console.WriteLine("Ttulo: " & Ttulo)
            Console.WriteLine("Autor: " & Autor)
            Console.WriteLine("Editorial: " & Editorial)
            MuestraProducto()
        End Sub
    End Class

    Sub Main()
        Dim Libro = New Derived("Superutilidades para C#", _
           "Wright", "McGraw-Hill/Osborne", 49.99, 0.6)

        Libro.MuestraLibro()

        Dim Miembro As MemberInfo
        Console.WriteLine()
        Console.WriteLine("Miembros:")
        For Each Miembro In Libro.GetType.GetMembers()
            Console.WriteLine(Miembro.Name & " " & Miembro.MemberType)
        Next

        Dim Propiedad As PropertyInfo
        Console.WriteLine()
        Console.WriteLine("Propiedades:")
        For Each Propiedad In Libro.GetType.GetProperties()
            Console.WriteLine(Propiedad.Name & " " & _
              Propiedad.PropertyType.ToString())
        Next

        Dim Mtodo As MethodInfo
        Console.WriteLine()
        Console.WriteLine("Mtodos:")
        For Each Mtodo In Libro.GetType.GetMethods()
            Console.WriteLine(Mtodo.Name & " " & _
               Mtodo.ReturnType.ToString())
        Next

        Dim Suceso As EventInfo
        Console.WriteLine()
        Console.WriteLine("Sucesos:")
        For Each Suceso In Libro.GetType.GetEvents()
            Console.WriteLine(Suceso.Name & " " & _
               Suceso.IsMulticast)
        Next

        Dim Interfaz As Type
        Console.WriteLine()
        Console.WriteLine("Suceso:")
        For Each Interfaz In Libro.GetType.GetInterfaces()
            Console.WriteLine(Interfaz.Name)
        Next

        Console.ReadLine()
    End Sub
End Module
